all: bt_com2.hex

bt_com2.elf: bt_com2.c mpu6050.c mpu6050dmp6.c twimastertimeout.c usart.c
	avr-g++ -Wall -Wextra -mmcu=atmega324pa -DF_CPU=16000000 -Os -o $@ $^

%.o: %.c
	avr-g++ -Wall -Wextra -mmcu=atmega324pa -DF_CPU=16000000 -Os -o $@ -c $^ 

bt_com2.hex: bt_com2.elf
	avr-objcopy -j .text -j .data -O ihex $^ $@
	avr-size $^

clean:
	rm -rf bt_com2.hex bt_com2.elf

.PHONY: all clean upload