#include <avr/interrupt.h>
#include <avr/io.h>

#include <util/delay.h>

#include <stdio.h>
#include <stdlib.h>

#include "usart.h"

static int forward, right, left, reverse;

void init_driver() {
	// set outputs
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD5);
	DDRD |= (1 << PD6);
	DDRD |= (1 << PD7);

}

void control() {
	if (forward == 1) {
		//go Forward
		PORTD |= (1 << PD4);
		PORTD |= (1 << PD7);
		PORTD &= ~(1 << PD5);
		PORTD &= ~(1 << PD6);
		if (right == 1) {
			// Deactivate right engine
			PORTD &= ~(1 << PD7);
		}

		if (left == 1) {
			// Deactivate left engine
			PORTD &= ~(1 << PD4);
		}
	} else if (reverse == 1) {
		// go backwards
		PORTD |= (1 << PD5);
		PORTD |= (1 << PD6);
		PORTD &= ~(1 << PD4);
		PORTD &= ~(1 << PD7);
		if (right == 1) {
			// Deactivate left engine
			PORTD &= ~(1 << PD4);
		}

		if (left == 1) {
			// Deactivate right engine
			PORTD &= ~(1 << PD7);
		}
	} else if (right == 1) {
		PORTD |= (1 << PD6);
		PORTD |= (1 << PD4);
		PORTD &= ~(1 << PD5);
		PORTD &= ~(1 << PD7);
	} else if (left == 1) {
		PORTD |= (1 << PD5);
		PORTD |= (1 << PD7);
		PORTD &= ~(1 << PD4);
		PORTD &= ~(1 << PD6);
	} else {
		// Deactivate engines
		PORTD &= ~(1 << PA4);
		PORTD &= ~(1 << PA5);
		PORTD &= ~(1 << PA6);
		PORTD &= ~(1 << PA7);
	}
}

void drive(char c){

	forward = 0;
	reverse = 0;
	left = 0;
	right = 0;
	if (c == 'w') {
		forward = 1;
	} else if (c == 'q') {
		forward = 1;
		left = 1;
	} else if (c == 'a') {
		left = 1;
	} else if (c == 'z') {
		reverse = 1;
		left = 1;
	} else if (c == 'x') {
		reverse = 1;
	} else if (c == 'c') {
		reverse = 1;
		right = 1;
	} else if (c == 'd') {
		right = 1;
	} else if (c == 'e') {
		forward = 1;
		right = 1;
	} else if (c == 's') {
	}

	control();
}



int main(void) {

	init_driver();

	USART0_init();

	PORTD &= ~(1 << PA4);
	PORTD &= ~(1 << PA5);
	PORTD &= ~(1 << PA6);
	PORTD &= ~(1 << PA7);
	char c = 's';
	while(1){
		c = USART0_receive();
		drive(c);
	}

/*	c = 'w'; //q s z x
	drive(c);
	_delay_ms(3000);
	c = 'q'; //q s z x
	drive(c);
	_delay_ms(3000);
	c = 's'; //q s z x
	drive(c);
	_delay_ms(3000);
	c = 'a'; //q s z x
	drive(c);
	_delay_ms(3000);
	c = 'x'; //q s z x
	drive(c);
	_delay_ms(3000);
	c = 's';
	drive(c);
*/}


